*!* ---Begin GridWithToolTip.prg---
*!*
*!*	From: Igor Korolyov <k1i2v3@km.ru> Tue 16 Apr 02 16:50
*!*	: Re: ToolTipTex in Grid
*!*
*!*	H      (  VFP7, ..  c-
*!*	hWnd ,     6-    FoxTools.fll
*!*
Create Table test1 (nId I, cName C(180), cMemo M)
For I = 1 To 20
	Insert Into test1 (nId, cName, cMemo) Values (Int (Rand ()*1000000), ;
		"  " + Replicate (Transform (Rand()*100000000000) + " ", 5)+ "  ", ;
		"    " + Replicate (Transform (Rand()*100000000000) + " ", 10) + "  ")
Endfor
Go Top In test1
Public oform1
oform1=Newobject("form1")
oform1.Show
Return

**************************************************
*-- Form:         form1 (e:\q\form1.scx)
*-- ParentClass:  form
*-- BaseClass:    form
*-- Time Stamp:   04/16/02 02:33:05 PM
Define Class form1 As Form

	Top = 0
	Height = 240
	Width = 372
	Caption = "Form1"
	Name = "Form1"

	Add Object grid1 As Grid With ;
		ColumnCount = -1, ;
		Height = 240, ;
		Left = 0, ;
		Top = 0, ;
		Width = 372, ;
		Name = "Grid1", ;
		RowSource = "test1"

	Add Object _tooltipengine1 As _tooltipengine

	Procedure Resize
		Thisform.grid1.Width = Thisform.Width
		Thisform.grid1.Height = Thisform.Height
	Endproc
	Procedure _tooltipengine1.Timer
		Local lcRect
		Local Array laTmp (4)
		If Thisform.LockScreen Or _Screen.LockScreen Or !Thisform.Visible Or !This.lShowTips
			Return
		Endif
		If Amouseobj (m.laTmp, 1) = 4 And Type ("m.laTmp(2)._cTooltipUniqID") == "C" And ;
				M.laTmp(2)._cTooltipUniqID = Thisform._cTooltipUniqID And ;
				TYPE ("m.laTmp(1)") == "O" And !Isnull (m.laTmp(1))
			If This.cLastObjPath == Sys (1272, m.laTmp(1))
				* Show tooltip
				m.lcRect = Space (16)
				= GetWindowRect (Thisform.HWnd, @ m.lcRect)
				If Lower (m.laTmp(2).BaseClass) == "toolbar"
					m.lnTop = m.laTmp (4) + Asc (Substr (m.lcRect, 5)) + 2^8 * Asc (Substr(m.lcRect, 6)) + ;
						2^16 * Asc (Substr (m.lcRect, 7)) + 2^24 * Asc (Substr (m.lcRect, 8))+ ;
						IIF (m.laTmp(2).Docked, 0, Sysmetric (34) + Sysmetric (4)) + 8
					m.lnLeft = m.laTmp (3) + Asc (m.lcRect) + 2^8 * Asc (Substr (m.lcRect,2)) + ;
						2^16 * Asc (Substr (m.lcRect, 3)) + 2^24 * Asc (Substr (m.lcRect, 4)) +;
						IIF (m.laTmp(2).Docked, Sysmetric (10), Sysmetric (3)) + 2
				Else && Form
					m.lnTop = m.laTmp (4) + Asc (Substr (m.lcRect, 5)) + 2^8 * Asc (Substr(m.lcRect, 6)) + ;
						2^16 * Asc (Substr (m.lcRect, 7)) + 2^24 * Asc (Substr (m.lcRect, 8))+ ;
						IIF (m.laTmp(2).TitleBar = 1, Iif (m.laTmp(2).HalfHeightCaption,Sysmetric (34), Sysmetric (9)), 0) + 12 - ;
						ThisForm.ViewPortTop
					m.lnLeft = m.laTmp (3) + Asc (m.lcRect) + 2^8 * Asc (Substr (m.lcRect,2)) + ;
						2^16 * Asc (Substr (m.lcRect, 3)) + 2^24 * Asc (Substr (m.lcRect, 4))+ ;
						+ 4 - Thisform.ViewPortLeft
				Endif
				Local lnWhat, lnRow, lnCol, lcCaption
				m.lcCaption = ""
				Thisform.LockScreen = .T.
				If Thisform.grid1.GridHitTest (m.laTmp (3), m.laTmp (4), ;
						@m.lnWhat, @m.lnRow, @m.lnCol)
					If m.lnWhat = 3
						m.lnCol = m.lnCol + Thisform.grid1.LeftColumn - 1
						If Thisform.grid1.RelativeRow # 0
							m.lnRow = m.lnRow - Thisform.grid1.RelativeRow
							If m.lnRow # 0
								Skip m.lnRow In Thisform.grid1.RecordSource
								m.lcCaption = ;
									TRANSFORM (Eval (Thisform.grid1.Columns(m.lnCol).ControlSource))
								Skip -m.lnRow In Thisform.grid1.RecordSource
							Else
								m.lcCaption = ;
									TRANSFORM (Eval (Thisform.grid1.Columns(m.lnCol).ControlSource))
							Endif
						Else
							Mouse Click Left
							m.lcCaption = ;
								TRANSFORM (Eval (Thisform.grid1.Columns(m.lnCol).ControlSource))
						Endif
					Else
						*      
						m.lcCaption = "  "
					Endif
				Endif
				This.oToolTip.lblText.Caption = Left (Alltrim (m.lcCaption),255)
				Thisform.LockScreen = .F.
				This.oToolTip.lblText.Width = Iif (Type ("m.laTmp(1)._nTooltipWidth") == "N" And ;
					!Empty (m.laTmp(1)._nTooltipWidth), ;
					M.laTmp(1)._nTooltipWidth, This.nDefaultWidth)
				_Screen.LockScreen = .T.
				This.oToolTip.lblText.Visible = .F.
				This.oToolTip.lblText.Visible = .T.
				m.lnWidth = This.oToolTip.lblText.Width
				m.lnHeight = This.oToolTip.lblText.Height
				This.oToolTip.Move (m.lnLeft, m.lnTop, m.lnWidth, m.lnHeight)
				_Screen.LockScreen = .F.
			Else
				This.cLastObjPath = Sys (1272, m.laTmp(1))
				This.oToolTip.Move (-1000, -1000, 0, 0)
			Endif
		Else
			* Hide tooltip
			This.cLastObjPath = ""
			This.oToolTip.Move (-1000, -1000, 0, 0)
		Endif
	Endproc

Enddefine
**************************************************
*-- Class:        _tooltipengine (e:\q\multilinetooltip.vcx)
*-- ParentClass:  timer
*-- BaseClass:    timer
*-- Time Stamp:   04/07/02 04:01:14 PM
*--     
Define Class _tooltipengine As Timer

	Height = 0
	Width = 0
	Interval = 200
	*--    (       _nTooltipWidth)
	nDefaultWidth = 100
	*--    
	lShowTips = .T.
	*--     ,    
	oToolTip = .F.
	Name = "_tooltipengine"

	*      Timer,
	* ..      

	Procedure Init
		If Version (5) < 700
			Return .F.
		Endif
		Declare Integer GetWindowRect In WIN32API ;
			INTEGER HWnd, String @ lpRect
		If This.lShowTips
			This.AddProperty ("cLastObjPath", "")
			Thisform.ShowTips = .F.
			This.oToolTip = Newobject ("_TooltipWindow", This.ClassLibrary)
			This.oToolTip.Move (-1000, -1000, 0, 0)
			This.oToolTip.Show ()
			Thisform.Show ()
			If Type ("ThisForm._TooltipUniqID") # "C"
				Thisform.AddProperty ("_cTooltipUniqID", Sys(2015))
			Endif
		Endif
	Endproc
Enddefine
**************************************************
*-- Class:        _tooltipwindow (e:\q\multilinetooltip.vcx)
*-- ParentClass:  form
*-- BaseClass:    form
*-- Time Stamp:   04/07/02 03:54:05 PM
*--      
Define Class _tooltipwindow As Form

	Desktop = .T.
	ShowWindow = 1
	BorderStyle = 1
	Caption = ""
	TabStop = .F.
	TitleBar = 0
	AlwaysOnTop = .T.
	Name = "_tooltipwindow"

	Add Object lblText As Label With ;
		AutoSize = .T., ;
		FontSize = 8, ;
		WordWrap = .T., ;
		BackStyle = 0, ;
		Caption = "TooltipText", ;
		Name = "lblText"

	Procedure Init
		Declare Integer GetSysColor In WIN32API Integer
		This.BackColor = GetSysColor (24) && TooltipBackColor
		This.lblText.ForeColor = GetSysColor (23) && TooltipForeColor
	Endproc
	Procedure lblText.MouseMove
		Lparameters nButton, nShift, nXCoord, nYCoord
		Thisform.Move (-1000, -1000, 0 ,0)
	Endproc
	Procedure lblText.Click
		Thisform.Move (-1000, -1000, 0 ,0)
	Endproc
ENDDEFINE
*!*
*!*	P.S.  ,     -   , 
*!*	   .      
*!*	     (  )   
*!*	(  ),    ,  
*!*	  MOUSE CLICK   .
*!*	   -  ...
*!*
*!*	WBR, Igor
*!* ---End GridWithToolTip.prg---
